# Class JME

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JPanel
jme.JME

All Implemented Interfaces:
  `KeyListener, MouseListener, MouseMotionListener, ImageObserver, MenuContainer, Serializable, EventListener, Accessible`

Direct Known Subclasses:
  `JmolJME`

public class JME extends JPanel implements MouseListener, KeyListener, MouseMotionListener

See Also:
  - Serialized Form

## Nested Class Summary

### Nested classes/interfaces inherited from class JPanel

`JPanel.AccessibleJPanel`

### Nested classes/interfaces inherited from class JComponent

`JComponent.AccessibleJComponent`

### Nested classes/interfaces inherited from class Container

`Container.AccessibleAWTContainer`

### Nested classes/interfaces inherited from class Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected boolean`
`afterClear`
`protected boolean`
`allHs`
`int[]`
`apointx`
`int[]`
`apointy`
`protected boolean`
`application`
`protected boolean`
`autoez`
`protected boolean`
`autonumber`
`int[]`
`bpointx`
`int[]`
`bpointy`
`protected boolean`
`bwMode`
`protected boolean`
`canonize`
`protected boolean`
`depict`
`protected boolean`
`depictBorder`
`protected boolean`
`doMenu`
`protected boolean`
`doTags`
`protected boolean`
`dyMode`
`protected boolean`
`embedded`
`protected String`
`infoText`
`protected boolean`
`jmeh`
`protected boolean`
`keepHydrogens`
`protected boolean`
`markUsed`
`JMEmol`
`mol`
`protected JMEmol[]`
`mols`
`protected boolean`
`mouseShift`
`protected boolean`
`movePossible`
`protected boolean`
`multipart`
`JFrame`
`myFrame`
`protected boolean`
`newMolecule`
`int`
`nmols`
`protected boolean`
`nocenter`
`protected boolean`
`number`
`protected boolean`
`polarnitro`
`protected boolean`
`query`
`protected boolean`
`rButton`
`protected boolean`
`reaction`
`protected boolean`
`relativeStereo`
`protected boolean`
`revertStereo`
`protected boolean`
`runsmi`
`protected boolean`
`showAtomNumbers`
`protected boolean`
`showHydrogens`
`protected boolean`
`star`
`protected boolean`
`stereo`
`protected boolean`
`webme`
`protected boolean`
`writemi`
`protected boolean`
`writemol`
`protected boolean`
`writesmi`
`protected boolean`
`xButton`

### Fields inherited from class JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

## Constructor Summary

Constructors
Constructor
Description
`JME()`
`JME(JFrame frame, boolean embedded)`

## Method Summary

Modifier and Type
Method
Description
`void`
`activateQuery()`
`void`
`clear()`
`protected boolean`
`doAction()`
`protected boolean`
`doMouseAtomAction()`
`protected void`
`doMouseBondAction()`
`protected void`
`doNewMoleculeAction(int x, int y)`
`Color`
`getColor()`
`void`
`getPreviousMolecule()`
`boolean`
`hasPrevious()`
`protected void`
`initialize()`
`String`
`jmeFile()`
`boolean`
`keyDown(KeyEvent e, int key)`
`void`
`keyPressed(KeyEvent e)`
`void`
`keyReleased(KeyEvent e)`
`void`
`keyTyped(KeyEvent e)`
`static void`
`main(String[] args)`
`String`
`molFile()`
`void`
`mouseClicked(MouseEvent e)`
`boolean`
`mouseDown(MouseEvent e, int x, int y)`
`boolean`
`mouseDrag(MouseEvent e, int x, int y)`
`void`
`mouseDragged(MouseEvent e)`
`void`
`mouseEntered(MouseEvent e)`
`void`
`mouseExited(MouseEvent e)`
`boolean`
`mouseMove(MouseEvent e, int x, int y)`
`void`
`mouseMoved(MouseEvent e)`
`void`
`mousePressed(MouseEvent e)`
`void`
`mouseReleased(MouseEvent e)`
`boolean`
`mouseUp(MouseEvent e, int x, int y)`
`String`
`nonisomericSmiles()`
`void`
`options(String parameters)`
`void`
`paint(Graphics g)`
`protected void`
`paintMolecularArea(BufferedImage img)`
`void`
`ping()`
`void`
`readMolecule(String molecule)`
`void`
`readMolFile(String s)`
`void`
`reset()`
`void`
`setFrame(JFrame frame)`
`protected boolean`
`setMol(boolean checkMultipart)`
`void`
`setSubstituent(String s)`
`void`
`setTemplate(String t, String name)`
`void`
`setText(String text)`
`void`
`showAtomNumbers()`
`String`
`smiles()`
`void`
`start()`
`void`
`stop()`
`void`
`update(Graphics g)`
`protected void`
`updateMark(int n)`

### Methods inherited from class JPanel

`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

### Methods inherited from class JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction`

### Methods inherited from class Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### myFrame

public JFrame myFrame

### application

protected boolean application

### infoText

protected String infoText

### bwMode

protected boolean bwMode

### runsmi

protected boolean runsmi

### canonize

protected boolean canonize

### stereo

protected boolean stereo

### multipart

protected boolean multipart

### xButton

protected boolean xButton

### rButton

protected boolean rButton

### showHydrogens

protected boolean showHydrogens

### query

protected boolean query

### reaction

protected boolean reaction

### autoez

protected boolean autoez

### writesmi

protected boolean writesmi

### writemi

protected boolean writemi

### writemol

protected boolean writemol

### number

protected boolean number

### star

protected boolean star

### autonumber

protected boolean autonumber

### jmeh

protected boolean jmeh

### depict

protected boolean depict

### depictBorder

protected boolean depictBorder

### keepHydrogens

protected boolean keepHydrogens

### nocenter

protected boolean nocenter

### polarnitro

protected boolean polarnitro

### showAtomNumbers

protected boolean showAtomNumbers

### doMenu

protected boolean doMenu

### movePossible

protected boolean movePossible

### newMolecule

protected boolean newMolecule

### afterClear

protected boolean afterClear

### mouseShift

protected boolean mouseShift

### dyMode

protected boolean dyMode

### mol

public JMEmol mol

### nmols

public int nmols

### mols

protected JMEmol[] mols

### doTags

protected boolean doTags

### webme

protected boolean webme

### apointx

public int[] apointx

### apointy

public int[] apointy

### bpointx

public int[] bpointx

### bpointy

public int[] bpointy

### revertStereo

protected boolean revertStereo

### relativeStereo

protected boolean relativeStereo

### allHs

protected boolean allHs

### markUsed

protected boolean markUsed

### embedded

protected boolean embedded

## Constructor Details

### JME

public JME()

### JME

public JME(JFrame frame, boolean embedded)

## Method Details

### setFrame

public void setFrame(JFrame frame)

### main

public static void main(String[] args)

### getColor

public Color getColor()

### activateQuery

public void activateQuery()

### initialize

protected void initialize()

### start

public void start()

### stop

public void stop()

### ping

public void ping()

### smiles

public String smiles()

### nonisomericSmiles

public String nonisomericSmiles()

### reset

public void reset()

### clear

public void clear()

### jmeFile

public String jmeFile()

### readMolecule

public void readMolecule(String molecule)

### setTemplate

public void setTemplate(String t, String name)

### molFile

public String molFile()

### readMolFile

public void readMolFile(String s)

### setMol

protected boolean setMol(boolean checkMultipart)

### setSubstituent

public void setSubstituent(String s)

### options

public void options(String parameters)

### setText

public void setText(String text)

### showAtomNumbers

public void showAtomNumbers()

### hasPrevious

public boolean hasPrevious()

### getPreviousMolecule

public void getPreviousMolecule()

### paint

public void paint(Graphics g)

Overrides:
  `paint` in class `JComponent`

### update

public void update(Graphics g)

Overrides:
  `update` in class `JComponent`

### paintMolecularArea

protected void paintMolecularArea(BufferedImage img)

### mouseDown

public boolean mouseDown(MouseEvent e, int x, int y)

### doAction

protected boolean doAction()

### doNewMoleculeAction

protected void doNewMoleculeAction(int x, int y)

### doMouseBondAction

protected void doMouseBondAction()

### doMouseAtomAction

protected boolean doMouseAtomAction()

### mouseUp

public boolean mouseUp(MouseEvent e, int x, int y)

Parameters:
  `e` -
  `x` -
  `y` -
Returns:
  ignored

### mouseDrag

public boolean mouseDrag(MouseEvent e, int x, int y)

### mouseMove

public boolean mouseMove(MouseEvent e, int x, int y)

Parameters:
  `e` -
  `x` -
  `y` -
Returns:
  ignored

### keyDown

public boolean keyDown(KeyEvent e, int key)

### updateMark

protected void updateMark(int n)

### mouseDragged

public void mouseDragged(MouseEvent e)

Specified by:
  `mouseDragged` in interface `MouseMotionListener`

### mouseMoved

public void mouseMoved(MouseEvent e)

Specified by:
  `mouseMoved` in interface `MouseMotionListener`

### keyTyped

public void keyTyped(KeyEvent e)

Specified by:
  `keyTyped` in interface `KeyListener`

### keyPressed

public void keyPressed(KeyEvent e)

Specified by:
  `keyPressed` in interface `KeyListener`

### keyReleased

public void keyReleased(KeyEvent e)

Specified by:
  `keyReleased` in interface `KeyListener`

### mouseClicked

public void mouseClicked(MouseEvent e)

Specified by:
  `mouseClicked` in interface `MouseListener`

### mousePressed

public void mousePressed(MouseEvent e)

Specified by:
  `mousePressed` in interface `MouseListener`

### mouseReleased

public void mouseReleased(MouseEvent e)

Specified by:
  `mouseReleased` in interface `MouseListener`

### mouseEntered

public void mouseEntered(MouseEvent e)

Specified by:
  `mouseEntered` in interface `MouseListener`

### mouseExited

public void mouseExited(MouseEvent e)

Specified by:
  `mouseExited` in interface `MouseListener`